/*
 * @(#)ImapSshExample.java
 *
 * Copyright (c) JSCAPE LLC.
 *
 * This software is the confidential and proprietary information of
 * JSCAPE. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with
 * the terms of the license agreement you entered into with JSCAPE.
 */

import com.jscape.inet.imap.*;
import com.jscape.inet.imapssh.*;
import com.jscape.inet.ssh.util.*;
import com.jscape.inet.email.*;
import com.jscape.inet.mime.*;
import java.util.Enumeration;
import java.io.*;

public class ImapSshExample {
    
    static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private SshParameters sshParams;
    
    public ImapSshExample(SshParameters sshParams) {
    	this.sshParams = sshParams;    	
    }
    
    // get messages from Imap mailbox
    public void getMessages(String hostname, String username, String password) throws ImapException, MimeException, IOException {
        ImapSsh imap = new ImapSsh(sshParams,hostname,username,password);
	System.out.println("attempting to establish connection");
        imap.connect();
	System.out.println("connection established");

        int messageCount = imap.getMessageCount();
	System.out.println("found " + messageCount + " messages.");
        
        for(int i = 1; i <= messageCount; i++) {
            EmailMessage msg = imap.getMessage(i);
            System.out.println("-- begin message --");
            System.out.println(new String(msg.getMessage()));
            System.out.println("-- end message --");
            System.out.print("ENTER for next message or type QUIT to quit: ");
            String command = reader.readLine();
            if(command.equalsIgnoreCase("quit")) {
                break;
            }            
        }       
        imap.disconnect();
    }  
    
    
    public static void main(String[] args) {
    	String sshHostname;
    	String sshUsername;
    	String sshPassword;    	
        String hostname;
        String username;
        String password;      

        try {        	
            System.out.print("Enter SSH hostname (e.g. ssh.myserver.com): ");
            sshHostname = reader.readLine();
            
            System.out.print("Enter SSH username (e.g. jsmith): ");
            sshUsername = reader.readLine();
            
            System.out.print("Enter SSH password (e.g. secret): ");
            sshPassword = reader.readLine();
            
            // create SSH connection parameters
            SshParameters sshParams = new SshParameters(sshHostname,sshUsername,sshPassword);
        	
            System.out.print("Enter Imap hostname (e.g. mail.domain.com): ");
            hostname = reader.readLine();
            System.out.print("Enter Imap Username: ");
            username = reader.readLine();
            System.out.print("Enter Imap Password: ");
            password = reader.readLine();
            ImapSshExample example = new ImapSshExample(sshParams);
            example.getMessages(hostname,username,password);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
}

