/*
 * @(#)NntpPostExample.java
 *
 * Copyright (c) JSCAPE LLC.
 *
 * This software is the confidential and proprietary information of
 * JSCAPE. ("Confidential Information").  You shall not disclose such
 * Confidential Information and shall use it only in accordance with
 * the terms of the license agreement you entered into with JSCAPE.
 */

import com.jscape.inet.nntp.*;
import com.jscape.inet.mime.*;
import java.util.Enumeration;
import java.io.*;

public class NntpPostExample {
    // post article to newsgroup
    public void postArticle(String hostname, String username, String password, String from,
    String newsgroup, String subject, String body)
    throws NntpException, MimeException {
        Nntp nntp = new Nntp();
        nntp.setDebug(true);
        nntp.setHostname(hostname);
        
        // connect and login
        if(username != null && password != null) {
            nntp.setUsername(username);
            nntp.setPassword(password);
        }
        nntp.connect();
        
        // build article message
        NntpArticle article = new NntpArticle();
        article.setFrom(from);
        article.setSubject(subject);
        article.setNewsgroups(newsgroup);
        article.setBody(body);    
        
        // post article and disconnect
        nntp.postArticle(article);
        nntp.disconnect();
    }
    
    public static void main(String[] args) {
        String hostname = null;
        String username = null;
        String password = null;
        String subject = null;
        String from = null;
        String body = null;
        String newsgroup = null;
        
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            System.out.print("Enter Nntp hostname (e.g. news.domain.com): ");
            hostname = reader.readLine();
            System.out.print("Enter Username (enter if no authorization needed): ");
            username = reader.readLine();
            if(username.trim().length() > 0) {
                System.out.print("Enter Password: ");
                password = reader.readLine();
            }
            System.out.print("Enter From (e.g. user@domain.com): ");
            from = reader.readLine();
            System.out.print("Enter Article Newsgroup (e.g. alt.test): ");
            newsgroup = reader.readLine();
            System.out.print("Enter Article Subject: ");
            subject = reader.readLine();
            System.out.print("Enter Article Body: ");
            body = reader.readLine();
            
            NntpPostExample example = new NntpPostExample();
            example.postArticle(hostname,username,password,from,newsgroup,subject,body);
            System.out.println("Article Posted!");
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        
    }
}

